# api/config/packages/security.yaml
security:
    encoders:
        App\Entity\User:
            algorithm: argon2i

    # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: email

    firewalls:
        dev:
            pattern: ^/_(profiler|wdt)
            security: false
        main:
            stateless: true
            anonymous: true
            provider: app_user_provider
            json_login:
                check_path: /authentication_token
                username_path: email
                password_path: password
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure
            guard:
                authenticators:
                    - lexik_jwt_authentication.jwt_token_authenticator

    role_hierarchy:
        ROLE_ADMIN: ROLE_RENTER
        ROLE_RENTER: ROLE_USER

    access_control:
        - { path: ^/docs, roles: IS_AUTHENTICATED_ANONYMOUSLY } # Allows accessing the Swagger UI
        - { path: ^/authentication_token, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/reset-password, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/verify/email, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/users, methods:["POST","GET"], roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/categories, methods:["GET"], roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/categories, methods: [ "POST","PATCH","PUT","DELETE"], roles: ["ROLE_ADMIN"] }
        - { path: ^/products, methods:["GET"], roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/regions, methods:["GET"], roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/reportings, methods: [ "GET","PATCH","PUT","DELETE" ], roles: ["ROLE_ADMIN"] }
        - { path: ^/reportings, methods: [ "POST" ], roles: [ "ROLE_USER" ] }
        - { path: ^/create-stripe-external-account, methods: [ "POST" ], roles: [ "ROLE_RENTER" ]}
        - { path: ^/renter-check-stripe-account, methods: [ "GET" ], roles: [ "ROLE_RENTER" ]}
        - { path: ^/reservations/user, methods: [ "GET" ], roles: [ "ROLE_USER","ROLE_ADMIN" ]}
        - { path: ^/reservations/renter, methods: [ "GET" ], roles: [ "ROLE_RENTER" ]}
        - { path: ^/success, methods:["GET"], roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/productsSearch, methods: [ "GET" ], roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/products/search, methods: [ "GET" ], roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/, roles: IS_AUTHENTICATED_FULLY }
